# IRsBitmapD3DSupport Interface Reference

Inherits IUnknown.

Inherited by CRdBitmap, and CRdBitmap.

List of all members.

## Public Member Functions
HRESULT | ConvertFromD3DTexture ([in] IUnknown *pTexture,[in] PALETTEENTRY *pPalette)
HRESULT | ConvertToD3DTexture ([in] BOOL bCompress,[in] BOOL bGenerateMipMaps,[in] IUnknown *pDevice,[out] IUnknown **pOutTexture)
HRESULT | ConvertToD3DTextureEx ([in] UINT Width,[in] UINT Height,[in] UINT MipLevels,[in] DWORD Usage,[in] DWORD Format,[in] DWORD ePool,[in] DWORD SizeFilter,[in] DWORD MipFilter,[in] IUnknown *pDevice,[out] IUnknown **pOutTexture)

## Detailed Description

IRsBitmapD3DSupport interface Support for conversion from and to D3D textures. Requires D3D9.

## Member Function Documentation

HRESULT IRsBitmapD3DSupport::ConvertFromD3DTexture | ( | [in] IUnknown * | pTexture,
|  | [in] PALETTEENTRY * | pPalette |
| ) |  |  |

This method is used to fill the bitmap from D3D texture.

Parameters:

  | pTexture | [in] Is casted to IUnknown to preserve independent behavior of the CommonData interfaces to some level. Real type expected in pTexture is IDirect3DTexture9.
  | pPalette | [in] .

Returns:
  Standard HRESULT processing can be applied to the result.

HRESULT IRsBitmapD3DSupport::ConvertToD3DTexture | ( | [in] BOOL | bCompress,
|  | [in] BOOL | bGenerateMipMaps,
|  | [in] IUnknown * | pDevice,
|  | [out] IUnknown ** | pOutTexture |
| ) |  |  |

This method is used to convert current bitmap to the D3D texture.

- If pDevice is NULL, internal one is used. But in this case only SCRATCH textures are safely generated!
- pOutTexture and pDevice is casted to IUnknown to preserve independent behavior of the CommonData interfaces to some level.
- Real type expected in pTexture is IDirect3DTexture9.
- Real type expected in pDevice is IDirect3DDevice9.

Parameters:

  | bCompress | [in] .
  | bGenerateMipMaps | [in] .
  | pDevice | [in] .
  | pOutTexture | [out] .

Returns:
  Standard HRESULT processing can be applied to the result.

HRESULT IRsBitmapD3DSupport::ConvertToD3DTextureEx | ( | [in] UINT | Width,
|  | [in] UINT | Height,
|  | [in] UINT | MipLevels,
|  | [in] DWORD | Usage,
|  | [in] DWORD | Format,
|  | [in] DWORD | ePool,
|  | [in] DWORD | SizeFilter,
|  | [in] DWORD | MipFilter,
|  | [in] IUnknown * | pDevice,
|  | [out] IUnknown ** | pOutTexture |
| ) |  |  |

This method is used to convert current bitmap to the D3D texture with extra customization.

- If pDevice is NULL, internal one is used.
- But in this case only SCRATCH textures are safely generated!
- If 0xFFFFFFFF is used for width or height then original dimensions are used.
- If D3DFMT_UNKNOWN is used for format then best format is used.
- Usage, Pool and MipLevels parameter can be set to any value specified in D3DXCreateTexture function.
- SizeFilter parameter can be set to any combination valid for D3DXLoadSurfaceFromSurface function and is used if original size and new size of texture differ.
- MipFilter parameter can be set to any combination valid for D3DXFilterTexture function and is used to specify mip-map filtering.
- Typecast D3DFORMAT to DWORD for Format parameter.
- Typecast D3DPOOL to DWORD for ePool parameter.
- pOutTexture and pDevice is casted to IUnknown to preserve independent behavior of the CommonData interfaces to some level.
- Real type expected in pTexture is IDirect3DTexture9.
- Real type expected in pDevice is IDirect3DDevice9.

Parameters:

  | Width | [in] .
  | Height | [in] .
  | MipLevels | [in] .
  | Usage | [in] .
  | Format | [in] .
  | ePool | [in] .
  | SizeFilter | [in] .
  | MipFilter | [in] .
  | pDevice | [in] .
  | pOutTexture | [out] .

Returns:
  Standard HRESULT processing can be applied to the result.